
<?php

require("../../config.php");
require_once("$CFG->dirroot/local/badiunet/util.php");
require_once("$CFG->dirroot/local/badiunet/netlib.php");
require_once("$CFG->dirroot/local/badiunet/factory/HttpQueryString.php");

new local_badiunet_remote_auth();


class local_badiunet_remote_auth {
    private $requesttoken=null;
    private $username=null;
    private $urltarget=null;
    function __construct() {
          $this->exec();
    }
    
    function exec() {
        //validate text token 
       $this->validateToken();
        //verify token online
        $this->checkRemote();
        //auth user
        $this->execLogin();
    }
    
    function printContent($content) {
        global $PAGE,$OUTPUT;
         $context = context_system::instance();
        $PAGE->set_context($context);
        $PAGE->set_url('/local/badiunet/fcservice/index.php');
        $PAGE->set_pagelayout('standard');
        $PAGE->set_title('Badiu.Net');
        $PAGE->set_heading('Badiu.Net');
        
        echo $OUTPUT->header();
        echo $content;
        echo $OUTPUT->footer();
        exit;
    }
        
    function validateToken(){
        $msg=null;
        $this->requesttoken=optional_param('_tokenauth',null,PARAM_TEXT); 
       if(empty($this->requesttoken)){$msg='Token remoto vazio';}
       else if(strlen($this->requesttoken)<120){$msg='Token remoto invalido';}
       if(!empty($msg)){$this->printContent($msg); }
    }
    
    function checkRemote(){
        $util=new local_badiunet_util();
        $netlib=new local_badiunet_netlib();
        $url=$netlib->getUrl();
        $url.="/system/service/process?";
        
        $querystr=new HttpQueryString();
        $querystr->add('_service','badiu.moodle.core.lib.datautil');
        $querystr->add('_function','remoteAccessAuth');
        $querystr->add('_token',$netlib->getToken());
        $querystr->add('_tokenauth',$this->requesttoken);
       // $querystr->add('_key',$this->getKey());
	
        $querystr->makeQuery();
        $query=$querystr->getQuery();
        $url.=$query;
        //echo $url;exit;
        $result=$util->request($url);
         //print_r($result);exit;
       if(isset($result['status']) && $result['status']=='danied'){
            $message=$result['message'];
            $this->printContent($message); 
        }else if(isset($result['status']) && $result['status']=='accept'){
           if(isset($result['message']['username'])){$this->username=$result['message']['username'];}
            if(isset($result['message']['urltarget'])){$this->urltarget=$result['message']['urltarget'];}
        }else{
            $this->printContent('Remote access failed');  
        }
    } 
     function execLogin(){
         if(empty($this->username)){
            $this->printContent('Username get by webservice is empty');   
         }
         global  $DB,$CFG;
         $user = $DB->get_record('user', array('username'=>$this->username));
         if(empty($user) || empty($user->id)){
              $this->printContent('Username get by webservice is not valid');
         }
         $resultath=complete_user_login($user);
         if(empty($resultath)){ $this->printContent('Login failed');}
         
         if(empty($this->urltarget)){$this->urltarget='';}
         redirect($CFG->httpswwwroot.$this->urltarget);
         exit;
     }
        
   
    function getRequesttoken() {
        return $this->requesttoken;
    }

    function getUsername() {
        return $this->username;
    }

    function getUrltarget() {
        return $this->urltarget;
    }

    function setRequesttoken($requesttoken) {
        $this->requesttoken = $requesttoken;
    }

    function setUsername($username) {
        $this->username = $username;
    }

    function setUrltarget($urltarget) {
        $this->urltarget = $urltarget;
    }


}

?>
